Sync with 2.25.5
[git] / git-submodule.sh
1 #!/bin/sh
2 #
3 # git-submodule.sh: add, init, update or list git submodules
4 #
5 # Copyright (c) 2007 Lars Hjemli
6
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] [--cached]
9    or: $dashless [--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
10    or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
11    or: $dashless [--quiet] init [--] [<path>...]
12    or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
13    or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--[no-]single-branch] [--] [<path>...]
14    or: $dashless [--quiet] set-branch (--default|--branch <branch>) [--] <path>
15    or: $dashless [--quiet] set-url [--] <path> <newurl>
16    or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
17    or: $dashless [--quiet] foreach [--recursive] <command>
18    or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
19    or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
20 OPTIONS_SPEC=
21 SUBDIRECTORY_OK=Yes
22 . git-sh-setup
23 . git-parse-remote
24 require_work_tree
25 wt_prefix=$(git rev-parse --show-prefix)
26 cd_to_toplevel
27
28 # Tell the rest of git that any URLs we get don't come
29 # directly from the user, so it can apply policy as appropriate.
30 GIT_PROTOCOL_FROM_USER=0
31 export GIT_PROTOCOL_FROM_USER
32
33 command=
34 branch=
35 force=
36 reference=
37 cached=
38 recursive=
39 init=
40 require_init=
41 files=
42 remote=
43 nofetch=
44 update=
45 prefix=
46 custom_name=
47 depth=
48 progress=
49 dissociate=
50 single_branch=
51
52 die_if_unmatched ()
53 {
54         if test "$1" = "#unmatched"
55         then
56                 exit ${2:-1}
57         fi
58 }
59
60 #
61 # Print a submodule configuration setting
62 #
63 # $1 = submodule name
64 # $2 = option name
65 # $3 = default value
66 #
67 # Checks in the usual git-config places first (for overrides),
68 # otherwise it falls back on .gitmodules.  This allows you to
69 # distribute project-wide defaults in .gitmodules, while still
70 # customizing individual repositories if necessary.  If the option is
71 # not in .gitmodules either, print a default value.
72 #
73 get_submodule_config () {
74         name="$1"
75         option="$2"
76         default="$3"
77         value=$(git config submodule."$name"."$option")
78         if test -z "$value"
79         then
80                 value=$(git submodule--helper config submodule."$name"."$option")
81         fi
82         printf '%s' "${value:-$default}"
83 }
84
85 isnumber()
86 {
87         n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
88 }
89
90 # Given a full hex object ID, is this the zero OID?
91 is_zero_oid () {
92         echo "$1" | sane_egrep '^0+$' >/dev/null 2>&1
93 }
94
95 # Sanitize the local git environment for use within a submodule. We
96 # can't simply use clear_local_git_env since we want to preserve some
97 # of the settings from GIT_CONFIG_PARAMETERS.
98 sanitize_submodule_env()
99 {
100         save_config=$GIT_CONFIG_PARAMETERS
101         clear_local_git_env
102         GIT_CONFIG_PARAMETERS=$save_config
103         export GIT_CONFIG_PARAMETERS
104 }
105
106 #
107 # Add a new submodule to the working tree, .gitmodules and the index
108 #
109 # $@ = repo path
110 #
111 # optional branch is stored in global branch variable
112 #
113 cmd_add()
114 {
115         # parse $args after "submodule ... add".
116         reference_path=
117         while test $# -ne 0
118         do
119                 case "$1" in
120                 -b | --branch)
121                         case "$2" in '') usage ;; esac
122                         branch=$2
123                         shift
124                         ;;
125                 -f | --force)
126                         force=$1
127                         ;;
128                 -q|--quiet)
129                         GIT_QUIET=1
130                         ;;
131                 --progress)
132                         progress=1
133                         ;;
134                 --reference)
135                         case "$2" in '') usage ;; esac
136                         reference_path=$2
137                         shift
138                         ;;
139                 --reference=*)
140                         reference_path="${1#--reference=}"
141                         ;;
142                 --dissociate)
143                         dissociate=1
144                         ;;
145                 --name)
146                         case "$2" in '') usage ;; esac
147                         custom_name=$2
148                         shift
149                         ;;
150                 --depth)
151                         case "$2" in '') usage ;; esac
152                         depth="--depth=$2"
153                         shift
154                         ;;
155                 --depth=*)
156                         depth=$1
157                         ;;
158                 --)
159                         shift
160                         break
161                         ;;
162                 -*)
163                         usage
164                         ;;
165                 *)
166                         break
167                         ;;
168                 esac
169                 shift
170         done
171
172         if ! git submodule--helper config --check-writeable >/dev/null 2>&1
173         then
174                  die "$(eval_gettext "please make sure that the .gitmodules file is in the working tree")"
175         fi
176
177         if test -n "$reference_path"
178         then
179                 is_absolute_path "$reference_path" ||
180                 reference_path="$wt_prefix$reference_path"
181
182                 reference="--reference=$reference_path"
183         fi
184
185         repo=$1
186         sm_path=$2
187
188         if test -z "$sm_path"; then
189                 sm_path=$(printf '%s\n' "$repo" |
190                         sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
191         fi
192
193         if test -z "$repo" || test -z "$sm_path"; then
194                 usage
195         fi
196
197         is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
198
199         # assure repo is absolute or relative to parent
200         case "$repo" in
201         ./*|../*)
202                 test -z "$wt_prefix" ||
203                 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
204
205                 # dereference source url relative to parent's url
206                 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
207                 ;;
208         *:*|/*)
209                 # absolute url
210                 realrepo=$repo
211                 ;;
212         *)
213                 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
214         ;;
215         esac
216
217         # normalize path:
218         # multiple //; leading ./; /./; /../; trailing /
219         sm_path=$(printf '%s/\n' "$sm_path" |
220                 sed -e '
221                         s|//*|/|g
222                         s|^\(\./\)*||
223                         s|/\(\./\)*|/|g
224                         :start
225                         s|\([^/]*\)/\.\./||
226                         tstart
227                         s|/*$||
228                 ')
229         if test -z "$force"
230         then
231                 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
232                 die "$(eval_gettext "'\$sm_path' already exists in the index")"
233         else
234                 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
235                 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
236         fi
237
238         if test -d "$sm_path" &&
239                 test -z $(git -C "$sm_path" rev-parse --show-cdup 2>/dev/null)
240         then
241             git -C "$sm_path" rev-parse --verify -q HEAD >/dev/null ||
242             die "$(eval_gettext "'\$sm_path' does not have a commit checked out")"
243         fi
244
245         if test -z "$force"
246         then
247             dryerr=$(git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" 2>&1 >/dev/null)
248             res=$?
249             if test $res -ne 0
250             then
251                  echo >&2 "$dryerr"
252                  exit $res
253             fi
254         fi
255
256         if test -n "$custom_name"
257         then
258                 sm_name="$custom_name"
259         else
260                 sm_name="$sm_path"
261         fi
262
263         if ! git submodule--helper check-name "$sm_name"
264         then
265                 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
266         fi
267
268         # perhaps the path exists and is already a git repo, else clone it
269         if test -e "$sm_path"
270         then
271                 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
272                 then
273                         eval_gettextln "Adding existing repo at '\$sm_path' to the index"
274                 else
275                         die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
276                 fi
277
278         else
279                 if test -d ".git/modules/$sm_name"
280                 then
281                         if test -z "$force"
282                         then
283                                 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
284                                 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^,"  ", -e s,' (fetch)',, >&2
285                                 die "$(eval_gettextln "\
286 If you want to reuse this local git directory instead of cloning again from
287   \$realrepo
288 use the '--force' option. If the local git directory is not the correct repo
289 or you are unsure what this means choose another name with the '--name' option.")"
290                         else
291                                 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
292                         fi
293                 fi
294                 git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${dissociate:+"--dissociate"} ${depth:+"$depth"} || exit
295                 (
296                         sanitize_submodule_env
297                         cd "$sm_path" &&
298                         # ash fails to wordsplit ${branch:+-b "$branch"...}
299                         case "$branch" in
300                         '') git checkout -f -q ;;
301                         ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
302                         esac
303                 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
304         fi
305         git config submodule."$sm_name".url "$realrepo"
306
307         git add --no-warn-embedded-repo $force "$sm_path" ||
308         die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
309
310         git submodule--helper config submodule."$sm_name".path "$sm_path" &&
311         git submodule--helper config submodule."$sm_name".url "$repo" &&
312         if test -n "$branch"
313         then
314                 git submodule--helper config submodule."$sm_name".branch "$branch"
315         fi &&
316         git add --force .gitmodules ||
317         die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
318
319         # NEEDSWORK: In a multi-working-tree world, this needs to be
320         # set in the per-worktree config.
321         if git config --get submodule.active >/dev/null
322         then
323                 # If the submodule being adding isn't already covered by the
324                 # current configured pathspec, set the submodule's active flag
325                 if ! git submodule--helper is-active "$sm_path"
326                 then
327                         git config submodule."$sm_name".active "true"
328                 fi
329         else
330                 git config submodule."$sm_name".active "true"
331         fi
332 }
333
334 #
335 # Execute an arbitrary command sequence in each checked out
336 # submodule
337 #
338 # $@ = command to execute
339 #
340 cmd_foreach()
341 {
342         # parse $args after "submodule ... foreach".
343         while test $# -ne 0
344         do
345                 case "$1" in
346                 -q|--quiet)
347                         GIT_QUIET=1
348                         ;;
349                 --recursive)
350                         recursive=1
351                         ;;
352                 -*)
353                         usage
354                         ;;
355                 *)
356                         break
357                         ;;
358                 esac
359                 shift
360         done
361
362         git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper foreach ${GIT_QUIET:+--quiet} ${recursive:+--recursive} -- "$@"
363 }
364
365 #
366 # Register submodules in .git/config
367 #
368 # $@ = requested paths (default to all)
369 #
370 cmd_init()
371 {
372         # parse $args after "submodule ... init".
373         while test $# -ne 0
374         do
375                 case "$1" in
376                 -q|--quiet)
377                         GIT_QUIET=1
378                         ;;
379                 --)
380                         shift
381                         break
382                         ;;
383                 -*)
384                         usage
385                         ;;
386                 *)
387                         break
388                         ;;
389                 esac
390                 shift
391         done
392
393         git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} -- "$@"
394 }
395
396 #
397 # Unregister submodules from .git/config and remove their work tree
398 #
399 cmd_deinit()
400 {
401         # parse $args after "submodule ... deinit".
402         deinit_all=
403         while test $# -ne 0
404         do
405                 case "$1" in
406                 -f|--force)
407                         force=$1
408                         ;;
409                 -q|--quiet)
410                         GIT_QUIET=1
411                         ;;
412                 --all)
413                         deinit_all=t
414                         ;;
415                 --)
416                         shift
417                         break
418                         ;;
419                 -*)
420                         usage
421                         ;;
422                 *)
423                         break
424                         ;;
425                 esac
426                 shift
427         done
428
429         git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} -- "$@"
430 }
431
432 is_tip_reachable () (
433         sanitize_submodule_env &&
434         cd "$1" &&
435         rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
436         test -z "$rev"
437 )
438
439 fetch_in_submodule () (
440         sanitize_submodule_env &&
441         cd "$1" &&
442         case "$2" in
443         '')
444                 git fetch ;;
445         *)
446                 shift
447                 git fetch $(get_default_remote) "$@" ;;
448         esac
449 )
450
451 #
452 # Update each submodule path to correct revision, using clone and checkout as needed
453 #
454 # $@ = requested paths (default to all)
455 #
456 cmd_update()
457 {
458         # parse $args after "submodule ... update".
459         while test $# -ne 0
460         do
461                 case "$1" in
462                 -q|--quiet)
463                         GIT_QUIET=1
464                         ;;
465                 -v)
466                         GIT_QUIET=0
467                         ;;
468                 --progress)
469                         progress=1
470                         ;;
471                 -i|--init)
472                         init=1
473                         ;;
474                 --require-init)
475                         init=1
476                         require_init=1
477                         ;;
478                 --remote)
479                         remote=1
480                         ;;
481                 -N|--no-fetch)
482                         nofetch=1
483                         ;;
484                 -f|--force)
485                         force=$1
486                         ;;
487                 -r|--rebase)
488                         update="rebase"
489                         ;;
490                 --reference)
491                         case "$2" in '') usage ;; esac
492                         reference="--reference=$2"
493                         shift
494                         ;;
495                 --reference=*)
496                         reference="$1"
497                         ;;
498                 --dissociate)
499                         dissociate=1
500                         ;;
501                 -m|--merge)
502                         update="merge"
503                         ;;
504                 --recursive)
505                         recursive=1
506                         ;;
507                 --checkout)
508                         update="checkout"
509                         ;;
510                 --recommend-shallow)
511                         recommend_shallow="--recommend-shallow"
512                         ;;
513                 --no-recommend-shallow)
514                         recommend_shallow="--no-recommend-shallow"
515                         ;;
516                 --depth)
517                         case "$2" in '') usage ;; esac
518                         depth="--depth=$2"
519                         shift
520                         ;;
521                 --depth=*)
522                         depth=$1
523                         ;;
524                 -j|--jobs)
525                         case "$2" in '') usage ;; esac
526                         jobs="--jobs=$2"
527                         shift
528                         ;;
529                 --jobs=*)
530                         jobs=$1
531                         ;;
532                 --single-branch)
533                         single_branch="--single-branch"
534                         ;;
535                 --no-single-branch)
536                         single_branch="--no-single-branch"
537                         ;;
538                 --)
539                         shift
540                         break
541                         ;;
542                 -*)
543                         usage
544                         ;;
545                 *)
546                         break
547                         ;;
548                 esac
549                 shift
550         done
551
552         if test -n "$init"
553         then
554                 cmd_init "--" "$@" || return
555         fi
556
557         {
558         git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
559                 ${progress:+"--progress"} \
560                 ${wt_prefix:+--prefix "$wt_prefix"} \
561                 ${prefix:+--recursive-prefix "$prefix"} \
562                 ${update:+--update "$update"} \
563                 ${reference:+"$reference"} \
564                 ${dissociate:+"--dissociate"} \
565                 ${depth:+--depth "$depth"} \
566                 ${require_init:+--require-init} \
567                 $single_branch \
568                 $recommend_shallow \
569                 $jobs \
570                 -- \
571                 "$@" || echo "#unmatched" $?
572         } | {
573         err=
574         while read -r quickabort sha1 just_cloned sm_path
575         do
576                 die_if_unmatched "$quickabort" "$sha1"
577
578                 git submodule--helper ensure-core-worktree "$sm_path" || exit 1
579
580                 update_module=$(git submodule--helper update-module-mode $just_cloned "$sm_path" $update)
581
582                 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
583
584                 if test $just_cloned -eq 1
585                 then
586                         subsha1=
587                 else
588                         subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
589                                 git rev-parse --verify HEAD) ||
590                         die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
591                 fi
592
593                 if test -n "$remote"
594                 then
595                         branch=$(git submodule--helper remote-branch "$sm_path")
596                         if test -z "$nofetch"
597                         then
598                                 # Fetch remote before determining tracking $sha1
599                                 fetch_in_submodule "$sm_path" $depth ||
600                                 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
601                         fi
602                         remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
603                         sha1=$(sanitize_submodule_env; cd "$sm_path" &&
604                                 git rev-parse --verify "${remote_name}/${branch}") ||
605                         die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
606                 fi
607
608                 if test "$subsha1" != "$sha1" || test -n "$force"
609                 then
610                         subforce=$force
611                         # If we don't already have a -f flag and the submodule has never been checked out
612                         if test -z "$subsha1" && test -z "$force"
613                         then
614                                 subforce="-f"
615                         fi
616
617                         if test -z "$nofetch"
618                         then
619                                 # Run fetch only if $sha1 isn't present or it
620                                 # is not reachable from a ref.
621                                 is_tip_reachable "$sm_path" "$sha1" ||
622                                 fetch_in_submodule "$sm_path" $depth ||
623                                 say "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'; trying to directly fetch \$sha1:")"
624
625                                 # Now we tried the usual fetch, but $sha1 may
626                                 # not be reachable from any of the refs
627                                 is_tip_reachable "$sm_path" "$sha1" ||
628                                 fetch_in_submodule "$sm_path" $depth "$sha1" ||
629                                 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
630                         fi
631
632                         must_die_on_failure=
633                         case "$update_module" in
634                         checkout)
635                                 command="git checkout $subforce -q"
636                                 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
637                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
638                                 ;;
639                         rebase)
640                                 command="git rebase"
641                                 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
642                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
643                                 must_die_on_failure=yes
644                                 ;;
645                         merge)
646                                 command="git merge"
647                                 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
648                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
649                                 must_die_on_failure=yes
650                                 ;;
651                         !*)
652                                 command="${update_module#!}"
653                                 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
654                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
655                                 must_die_on_failure=yes
656                                 ;;
657                         *)
658                                 die "$(eval_gettext "Invalid update mode '$update_module' for submodule path '$path'")"
659                         esac
660
661                         if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
662                         then
663                                 say "$say_msg"
664                         elif test -n "$must_die_on_failure"
665                         then
666                                 die_with_status 2 "$die_msg"
667                         else
668                                 err="${err};$die_msg"
669                                 continue
670                         fi
671                 fi
672
673                 if test -n "$recursive"
674                 then
675                         (
676                                 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
677                                 wt_prefix=
678                                 sanitize_submodule_env
679                                 cd "$sm_path" &&
680                                 eval cmd_update
681                         )
682                         res=$?
683                         if test $res -gt 0
684                         then
685                                 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
686                                 if test $res -ne 2
687                                 then
688                                         err="${err};$die_msg"
689                                         continue
690                                 else
691                                         die_with_status $res "$die_msg"
692                                 fi
693                         fi
694                 fi
695         done
696
697         if test -n "$err"
698         then
699                 OIFS=$IFS
700                 IFS=';'
701                 for e in $err
702                 do
703                         if test -n "$e"
704                         then
705                                 echo >&2 "$e"
706                         fi
707                 done
708                 IFS=$OIFS
709                 exit 1
710         fi
711         }
712 }
713
714 #
715 # Configures a submodule's default branch
716 #
717 # $@ = requested path
718 #
719 cmd_set_branch() {
720         unset_branch=false
721         branch=
722
723         while test $# -ne 0
724         do
725                 case "$1" in
726                 -q|--quiet)
727                         # we don't do anything with this but we need to accept it
728                         ;;
729                 -d|--default)
730                         unset_branch=true
731                         ;;
732                 -b|--branch)
733                         case "$2" in '') usage ;; esac
734                         branch=$2
735                         shift
736                         ;;
737                 --)
738                         shift
739                         break
740                         ;;
741                 -*)
742                         usage
743                         ;;
744                 *)
745                         break
746                         ;;
747                 esac
748                 shift
749         done
750
751         if test $# -ne 1
752         then
753                 usage
754         fi
755
756         # we can't use `git submodule--helper name` here because internally, it
757         # hashes the path so a trailing slash could lead to an unintentional no match
758         name="$(git submodule--helper list "$1" | cut -f2)"
759         if test -z "$name"
760         then
761                 exit 1
762         fi
763
764         test -n "$branch"; has_branch=$?
765         test "$unset_branch" = true; has_unset_branch=$?
766
767         if test $((!$has_branch != !$has_unset_branch)) -eq 0
768         then
769                 usage
770         fi
771
772         if test $has_branch -eq 0
773         then
774                 git submodule--helper config submodule."$name".branch "$branch"
775         else
776                 git submodule--helper config --unset submodule."$name".branch
777         fi
778 }
779
780 #
781 # Configures a submodule's remote url
782 #
783 # $@ = requested path, requested url
784 #
785 cmd_set_url() {
786         while test $# -ne 0
787         do
788                 case "$1" in
789                 -q|--quiet)
790                         GIT_QUIET=1
791                         ;;
792                 --)
793                         shift
794                         break
795                         ;;
796                 -*)
797                         usage
798                         ;;
799                 *)
800                         break
801                         ;;
802                 esac
803                 shift
804         done
805
806         if test $# -ne 2
807         then
808                 usage
809         fi
810
811         # we can't use `git submodule--helper name` here because internally, it
812         # hashes the path so a trailing slash could lead to an unintentional no match
813         name="$(git submodule--helper list "$1" | cut -f2)"
814         if test -z "$name"
815         then
816                 exit 1
817         fi
818
819         url="$2"
820         if test -z "$url"
821         then
822                 exit 1
823         fi
824
825         git submodule--helper config submodule."$name".url "$url"
826         git submodule--helper sync ${GIT_QUIET:+--quiet} "$name"
827 }
828
829 #
830 # Show commit summary for submodules in index or working tree
831 #
832 # If '--cached' is given, show summary between index and given commit,
833 # or between working tree and given commit
834 #
835 # $@ = [commit (default 'HEAD'),] requested paths (default all)
836 #
837 cmd_summary() {
838         summary_limit=-1
839         for_status=
840         diff_cmd=diff-index
841
842         # parse $args after "submodule ... summary".
843         while test $# -ne 0
844         do
845                 case "$1" in
846                 --cached)
847                         cached="$1"
848                         ;;
849                 --files)
850                         files="$1"
851                         ;;
852                 --for-status)
853                         for_status="$1"
854                         ;;
855                 -n|--summary-limit)
856                         summary_limit="$2"
857                         isnumber "$summary_limit" || usage
858                         shift
859                         ;;
860                 --summary-limit=*)
861                         summary_limit="${1#--summary-limit=}"
862                         isnumber "$summary_limit" || usage
863                         ;;
864                 --)
865                         shift
866                         break
867                         ;;
868                 -*)
869                         usage
870                         ;;
871                 *)
872                         break
873                         ;;
874                 esac
875                 shift
876         done
877
878         test $summary_limit = 0 && return
879
880         if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
881         then
882                 head=$rev
883                 test $# = 0 || shift
884         elif test -z "$1" || test "$1" = "HEAD"
885         then
886                 # before the first commit: compare with an empty tree
887                 head=$(git hash-object -w -t tree --stdin </dev/null)
888                 test -z "$1" || shift
889         else
890                 head="HEAD"
891         fi
892
893         if [ -n "$files" ]
894         then
895                 test -n "$cached" &&
896                 die "$(gettext "The --cached option cannot be used with the --files option")"
897                 diff_cmd=diff-files
898                 head=
899         fi
900
901         cd_to_toplevel
902         eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
903         # Get modified modules cared by user
904         modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
905                 sane_egrep '^:([0-7]* )?160000' |
906                 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
907                 do
908                         # Always show modules deleted or type-changed (blob<->module)
909                         if test "$status" = D || test "$status" = T
910                         then
911                                 printf '%s\n' "$sm_path"
912                                 continue
913                         fi
914                         # Respect the ignore setting for --for-status.
915                         if test -n "$for_status"
916                         then
917                                 name=$(git submodule--helper name "$sm_path")
918                                 ignore_config=$(get_submodule_config "$name" ignore none)
919                                 test $status != A && test $ignore_config = all && continue
920                         fi
921                         # Also show added or modified modules which are checked out
922                         GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
923                         printf '%s\n' "$sm_path"
924                 done
925         )
926
927         test -z "$modules" && return
928
929         git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
930         sane_egrep '^:([0-7]* )?160000' |
931         cut -c2- |
932         while read -r mod_src mod_dst sha1_src sha1_dst status name
933         do
934                 if test -z "$cached" &&
935                         is_zero_oid $sha1_dst
936                 then
937                         case "$mod_dst" in
938                         160000)
939                                 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
940                                 ;;
941                         100644 | 100755 | 120000)
942                                 sha1_dst=$(git hash-object $name)
943                                 ;;
944                         000000)
945                                 ;; # removed
946                         *)
947                                 # unexpected type
948                                 eval_gettextln "unexpected mode \$mod_dst" >&2
949                                 continue ;;
950                         esac
951                 fi
952                 missing_src=
953                 missing_dst=
954
955                 test $mod_src = 160000 &&
956                 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
957                 missing_src=t
958
959                 test $mod_dst = 160000 &&
960                 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
961                 missing_dst=t
962
963                 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
964
965                 total_commits=
966                 case "$missing_src,$missing_dst" in
967                 t,)
968                         errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commit \$sha1_src")"
969                         ;;
970                 ,t)
971                         errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commit \$sha1_dst")"
972                         ;;
973                 t,t)
974                         errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
975                         ;;
976                 *)
977                         errmsg=
978                         total_commits=$(
979                         if test $mod_src = 160000 && test $mod_dst = 160000
980                         then
981                                 range="$sha1_src...$sha1_dst"
982                         elif test $mod_src = 160000
983                         then
984                                 range=$sha1_src
985                         else
986                                 range=$sha1_dst
987                         fi
988                         GIT_DIR="$name/.git" \
989                         git rev-list --first-parent $range -- | wc -l
990                         )
991                         total_commits=" ($(($total_commits + 0)))"
992                         ;;
993                 esac
994
995                 sha1_abbr_src=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_src 2>/dev/null ||
996                         echo $sha1_src | cut -c1-7)
997                 sha1_abbr_dst=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_dst 2>/dev/null ||
998                         echo $sha1_dst | cut -c1-7)
999
1000                 if test $status = T
1001                 then
1002                         blob="$(gettext "blob")"
1003                         submodule="$(gettext "submodule")"
1004                         if test $mod_dst = 160000
1005                         then
1006                                 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1007                         else
1008                                 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1009                         fi
1010                 else
1011                         echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1012                 fi
1013                 if test -n "$errmsg"
1014                 then
1015                         # Don't give error msg for modification whose dst is not submodule
1016                         # i.e. deleted or changed to blob
1017                         test $mod_dst = 160000 && echo "$errmsg"
1018                 else
1019                         if test $mod_src = 160000 && test $mod_dst = 160000
1020                         then
1021                                 limit=
1022                                 test $summary_limit -gt 0 && limit="-$summary_limit"
1023                                 GIT_DIR="$name/.git" \
1024                                 git log $limit --pretty='format:  %m %s' \
1025                                 --first-parent $sha1_src...$sha1_dst
1026                         elif test $mod_dst = 160000
1027                         then
1028                                 GIT_DIR="$name/.git" \
1029                                 git log --pretty='format:  > %s' -1 $sha1_dst
1030                         else
1031                                 GIT_DIR="$name/.git" \
1032                                 git log --pretty='format:  < %s' -1 $sha1_src
1033                         fi
1034                         echo
1035                 fi
1036                 echo
1037         done
1038 }
1039 #
1040 # List all submodules, prefixed with:
1041 #  - submodule not initialized
1042 #  + different revision checked out
1043 #
1044 # If --cached was specified the revision in the index will be printed
1045 # instead of the currently checked out revision.
1046 #
1047 # $@ = requested paths (default to all)
1048 #
1049 cmd_status()
1050 {
1051         # parse $args after "submodule ... status".
1052         while test $# -ne 0
1053         do
1054                 case "$1" in
1055                 -q|--quiet)
1056                         GIT_QUIET=1
1057                         ;;
1058                 --cached)
1059                         cached=1
1060                         ;;
1061                 --recursive)
1062                         recursive=1
1063                         ;;
1064                 --)
1065                         shift
1066                         break
1067                         ;;
1068                 -*)
1069                         usage
1070                         ;;
1071                 *)
1072                         break
1073                         ;;
1074                 esac
1075                 shift
1076         done
1077
1078         git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} -- "$@"
1079 }
1080 #
1081 # Sync remote urls for submodules
1082 # This makes the value for remote.$remote.url match the value
1083 # specified in .gitmodules.
1084 #
1085 cmd_sync()
1086 {
1087         while test $# -ne 0
1088         do
1089                 case "$1" in
1090                 -q|--quiet)
1091                         GIT_QUIET=1
1092                         shift
1093                         ;;
1094                 --recursive)
1095                         recursive=1
1096                         shift
1097                         ;;
1098                 --)
1099                         shift
1100                         break
1101                         ;;
1102                 -*)
1103                         usage
1104                         ;;
1105                 *)
1106                         break
1107                         ;;
1108                 esac
1109         done
1110
1111         git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} -- "$@"
1112 }
1113
1114 cmd_absorbgitdirs()
1115 {
1116         git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1117 }
1118
1119 # This loop parses the command line arguments to find the
1120 # subcommand name to dispatch.  Parsing of the subcommand specific
1121 # options are primarily done by the subcommand implementations.
1122 # Subcommand specific options such as --branch and --cached are
1123 # parsed here as well, for backward compatibility.
1124
1125 while test $# != 0 && test -z "$command"
1126 do
1127         case "$1" in
1128         add | foreach | init | deinit | update | set-branch | set-url | status | summary | sync | absorbgitdirs)
1129                 command=$1
1130                 ;;
1131         -q|--quiet)
1132                 GIT_QUIET=1
1133                 ;;
1134         -b|--branch)
1135                 case "$2" in
1136                 '')
1137                         usage
1138                         ;;
1139                 esac
1140                 branch="$2"; shift
1141                 ;;
1142         --cached)
1143                 cached="$1"
1144                 ;;
1145         --)
1146                 break
1147                 ;;
1148         -*)
1149                 usage
1150                 ;;
1151         *)
1152                 break
1153                 ;;
1154         esac
1155         shift
1156 done
1157
1158 # No command word defaults to "status"
1159 if test -z "$command"
1160 then
1161     if test $# = 0
1162     then
1163         command=status
1164     else
1165         usage
1166     fi
1167 fi
1168
1169 # "-b branch" is accepted only by "add" and "set-branch"
1170 if test -n "$branch" && (test "$command" != add || test "$command" != set-branch)
1171 then
1172         usage
1173 fi
1174
1175 # "--cached" is accepted only by "status" and "summary"
1176 if test -n "$cached" && test "$command" != status && test "$command" != summary
1177 then
1178         usage
1179 fi
1180
1181 "cmd_$(echo $command | sed -e s/-/_/g)" "$@"